﻿/// <reference path="../Scripts/msls.js" />

window.myapp = msls.application;

(function (lightSwitchApplication) {

    var $Entity = msls.Entity,
        $DataService = msls.DataService,
        $DataWorkspace = msls.DataWorkspace,
        $defineEntity = msls._defineEntity,
        $defineDataService = msls._defineDataService,
        $defineDataWorkspace = msls._defineDataWorkspace,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString;

    function Tickets(entitySet) {
        /// <summary>
        /// Represents the Tickets entity type.
        /// </summary>
        /// <param name="entitySet" type="msls.EntitySet" optional="true">
        /// The entity set that should contain this tickets.
        /// </param>
        /// <field name="Id" type="Number">
        /// Gets or sets the id for this tickets.
        /// </field>
        /// <field name="Title" type="String">
        /// Gets or sets the title for this tickets.
        /// </field>
        /// <field name="Category" type="String">
        /// Gets or sets the category for this tickets.
        /// </field>
        /// <field name="Status" type="String">
        /// Gets or sets the status for this tickets.
        /// </field>
        /// <field name="Date_Create" type="Date">
        /// Gets or sets the date_Create for this tickets.
        /// </field>
        /// <field name="CreatedBy" type="String">
        /// Gets or sets the createdBy for this tickets.
        /// </field>
        /// <field name="Created" type="Date">
        /// Gets or sets the created for this tickets.
        /// </field>
        /// <field name="ModifiedBy" type="String">
        /// Gets or sets the modifiedBy for this tickets.
        /// </field>
        /// <field name="Modified" type="Date">
        /// Gets or sets the modified for this tickets.
        /// </field>
        /// <field name="RowVersion" type="Array">
        /// Gets or sets the rowVersion for this tickets.
        /// </field>
        /// <field name="details" type="msls.application.Tickets.Details">
        /// Gets the details for this tickets.
        /// </field>
        $Entity.call(this, entitySet);
    }

    function ApplicationData(dataWorkspace) {
        /// <summary>
        /// Represents the ApplicationData data service.
        /// </summary>
        /// <param name="dataWorkspace" type="msls.DataWorkspace">
        /// The data workspace that created this data service.
        /// </param>
        /// <field name="TicketsSet" type="msls.EntitySet">
        /// Gets the TicketsSet entity set.
        /// </field>
        /// <field name="details" type="msls.application.ApplicationData.Details">
        /// Gets the details for this data service.
        /// </field>
        $DataService.call(this, dataWorkspace);
    };
    function DataWorkspace() {
        /// <summary>
        /// Represents the data workspace.
        /// </summary>
        /// <field name="ApplicationData" type="msls.application.ApplicationData">
        /// Gets the ApplicationData data service.
        /// </field>
        /// <field name="details" type="msls.application.DataWorkspace.Details">
        /// Gets the details for this data workspace.
        /// </field>
        $DataWorkspace.call(this);
    };

    msls._addToNamespace("msls.application", {

        Tickets: $defineEntity(Tickets, [
            { name: "Id", type: Number },
            { name: "Title", type: String },
            { name: "Category", type: String },
            { name: "Status", type: String },
            { name: "Date_Create", type: Date },
            { name: "CreatedBy", type: String, isReadOnly: true },
            { name: "Created", type: Date, isReadOnly: true },
            { name: "ModifiedBy", type: String, isReadOnly: true },
            { name: "Modified", type: Date, isReadOnly: true },
            { name: "RowVersion", type: Array }
        ]),

        ApplicationData: $defineDataService(ApplicationData, lightSwitchApplication.rootUri + "/ApplicationData.svc", [
            { name: "TicketsSet", elementType: Tickets }
        ], [
            {
                name: "TicketsSet_SingleOrDefault", value: function (Id) {
                    return new $DataServiceQuery({ _entitySet: this.TicketsSet },
                        lightSwitchApplication.rootUri + "/ApplicationData.svc" + "/TicketsSet(" + "Id=" + $toODataString(Id, "Int32?") + ")"
                    );
                }
            }
        ]),

        DataWorkspace: $defineDataWorkspace(DataWorkspace, [
            { name: "ApplicationData", type: ApplicationData }
        ])

    });

}(msls.application));
