﻿/// <reference path="data.js" />

(function (lightSwitchApplication) {

    var $Screen = msls.Screen,
        $defineScreen = msls._defineScreen,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString,
        $defineShowScreen = msls._defineShowScreen;

    function AddEditTickets(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditTickets screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Tickets" type="msls.application.Tickets">
        /// Gets or sets the tickets for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditTickets.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditTickets", parameters);
    }

    function ShowTickets(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the ShowTickets screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="TicketsSet" type="msls.VisualCollection" elementType="msls.application.Tickets">
        /// Gets the ticketsSet for this screen.
        /// </field>
        /// <field name="details" type="msls.application.ShowTickets.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "ShowTickets", parameters);
    }

    function SSRSViewer(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the SSRSViewer screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="details" type="msls.application.SSRSViewer.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "SSRSViewer", parameters);
    }

    msls._addToNamespace("msls.application", {

        AddEditTickets: $defineScreen(AddEditTickets, [
            { name: "Tickets", kind: "local", type: lightSwitchApplication.Tickets }
        ], [
        ]),

        ShowTickets: $defineScreen(ShowTickets, [
            {
                name: "TicketsSet", kind: "collection", elementType: lightSwitchApplication.Tickets,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.TicketsSet;
                }
            }
        ], [
            { name: "AddTicket" }
        ]),

        SSRSViewer: $defineScreen(SSRSViewer, [
        ], [
        ]),

        showAddEditTickets: $defineShowScreen(function showAddEditTickets(Tickets, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditTickets screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditTickets", parameters, options);
        }),

        showShowTickets: $defineShowScreen(function showShowTickets(options) {
            /// <summary>
            /// Asynchronously navigates forward to the ShowTickets screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("ShowTickets", parameters, options);
        }),

        showSSRSViewer: $defineShowScreen(function showSSRSViewer(options) {
            /// <summary>
            /// Asynchronously navigates forward to the SSRSViewer screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("SSRSViewer", parameters, options);
        })

    });

}(msls.application));
