﻿using System.Collections;
using Syncfusion.EJ.ReportViewer;
using Syncfusion.Reports.EJ;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace LightSwitchApplication
{
    public class ReportAPIController : ApiController, IReportController
    {
        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            return ReportHelper.ProcessReport(jsonResult, this);
        }

        [System.Web.Http.ActionName("GetResource")]
        [AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }

        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            var hostedPath = System.Web.HttpContext.Current.Server.MapPath("~/");
            var rdlPath = hostedPath + "bin\\LSSSRSDemo.Server\\ReportTemplate\\" + reportOption.ReportModel.ReportPath;
            reportOption.ReportModel.ReportPath = rdlPath;

        }

        public void OnReportLoaded(ReportViewerOptions reportOption)
        {
            reportOption.ReportModel.DataSources.Clear();
            reportOption.ReportModel.DataSources.Add(new ReportDataSource { Name = "ETickets", Value = ETickets.GetTickets() });
        }
    }

    public class ETickets
    {
        public int Id { get; set; }
        public string Title { get; set; }
        public string Category { get; set; }
        public string Status { get; set; }
        public DateTime Date_Create { get; set; }

        public static List<ETickets> GetTickets()
        {
            List<ETickets> _tickets = new List<ETickets>();

            using (ServerApplicationContext context = ServerApplicationContext.CreateContext())
            {
                foreach (var item in context.DataWorkspace.ApplicationData.TicketsSet)
                {
                    ETickets _ticket = new ETickets();
                    var _tick = (item as LightSwitchApplication.Tickets);
                    _ticket.Id = (item as LightSwitchApplication.Tickets).Id;
                    _ticket.Title = _tick.Title;
                    _ticket.Category = _tick.Category;
                    _ticket.Status = _tick.Status;
                    _ticket.Date_Create = _tick.Date_Create;
                    _tickets.Add(_ticket);
                }
            }
            return _tickets;
        }
    }

}